<script setup lang="ts">
// write your code here ...
import AddEditModal from '../components/DstrapModal.vue'
import { ref, reactive, onMounted, nextTick } from "vue";
import { useRouter, useRoute } from 'vue-router'
import { useFormStore } from "@/stores/forms"
import TextLayout from '@/modules/Reference/components/InputTypesLayouts/TextLayout.vue'
import DropdownLayout from '@/modules/Reference/components/InputTypesLayouts/DropdownLayout.vue'
import RangeLayout from '@/modules/Reference/components/InputTypesLayouts/RangeLayout.vue'
import ChipsLayout from '@/modules/Reference/components/InputTypesLayouts/ChipsLayout.vue'
import FileLayout from '@/modules/Reference/components/InputTypesLayouts/FileLayout.vue'
import ImageLayout from '@/modules/Reference/components/InputTypesLayouts/ImageLayout.vue'
import CheckboxLayout from '@/modules/Reference/components/InputTypesLayouts/CheckboxLayout.vue'
import { toast } from "vue3-toastify";
import { useI18n } from 'vue-i18n'
const { t, locale } = useI18n()

const openShowModal = ref(false)

const openModal = () => {
    lngObj.value = {}
    openShowModal.value = !openShowModal.value
}

const editItem = (value: LngData) => {
    lngObj.value = value
    openShowModal.value = !openShowModal.value
}

interface LngData {
    ru: string,
    uz: string,
    cryl: string
}


interface DragData {
    index: number,
    blockIndex: string | number,
    data: object

}

interface OneField {
    id?: number | null,
    block_id?: number | null,
    width: string | number,
    type: string,
    slug: string,
    label?: LngData,
    placeholder?: LngData,
    tooltip?: LngData,
    pattern?: string,
    validation?: object,
    min_value?: string | number,
    max_value?: string | number,
    required: boolean,
    is_multiple?: boolean,
    options?: LngData[],
    size_type?: string,
    is_switch?: boolean,
    is_chips?: boolean,

}

interface OneBlock {
    id?: number | null,
    title: {
        ru: string,
        uz: string,
        cryl: string
    },
    vertical: boolean,
    inputs: OneField[]
}

interface formData {
    id?: number,
    target: number,
    active: boolean,
    name: {
        ru: string,
        uz: string,
        cryl: string
    },
    description: {
        ru: string,
        uz: string,
        cryl: string
    },
    fields: OneBlock[]
}

interface InputItem {
    id: number,
    inputs: object[]
}

interface InputFileEvent extends Event {
    target: HTMLInputElement;
}

const lngObj = ref<{ ru: string, uz: string, cryl: string } | null>(null)

const formData = ref<formData>({
    target: 1,
    active: true,
    name: {
        ru: "",
        uz: "",
        cryl: ""
    },
    description: {
        ru: "",
        uz: "",
        cryl: ""
    },
    fields: [
        {
            title: {
                ru: "",
                uz: "",
                cryl: ""
            },
            vertical: true,
            inputs: []
        }
    ]
})

const formStore = useFormStore()
const router = useRouter()
const route = useRoute()

onMounted(async () => {

    if (route.params.id) {
        await formStore.getOneFormAction(route.params.id)


        formData.value = formStore.getOneForm.data.data


    }

})



const dragData = ref<DragData>({})
let defaultIndex = ref<number | null>(null)
let currentData = ref<OneField>({
    type: '',
    width: '',
    id: null,
    slug: '',
    label: {
        ru: "",
        uz: "",
        cryl: ""
    },
    placeholder: {
        ru: "",
        uz: "",
        cryl: ""
    },
    tooltip: {
        ru: "",
        uz: "",
        cryl: ""
    },
    pattern: '',
    validation: {},
    min_value: '',
    max_value: '',
    required: false
})

const isOpen = reactive<boolean[]>([])
let id = ref<number>(0)
let dragging = ref<number>(-1)

const fieldList = ref<object[]>([
    {
        title: 'Text',
        unique_name: 'text'
    },
    {
        title: 'Chips',
        unique_name: 'chips'
    },
    {
        title: 'Range',
        unique_name: 'range'
    },
    {
        title: 'Switch',
        unique_name: 'switch'
    },
    {
        title: 'Checkbox',
        unique_name: 'checkbox'
    },
    {
        title: 'Single Select Dropdown',
        unique_name: 'single_select_drop_down'
    },
    {
        title: 'Multi Select Dropdown',
        unique_name: 'multi_select_drop_down'
    },
    {
        title: 'Radio',
        unique_name: 'radio'
    },
    {
        title: 'File upload',
        unique_name: 'file_upload'
    },
    {
        title: 'Image upload',
        unique_name: 'image_upload'
    },
    {
        title: 'Map',
        unique_name: 'map'
    },
])

const addField = (blockIndex: number): void => {
    if (!formData.value.fields[blockIndex].vertical && formData.value.fields[blockIndex].inputs.length >= 2) {
        alert("You cannot add input more than 2")
        return
    }

    formData.value.fields[blockIndex].inputs.push({
        id: null,
        block_id: null,
        width: '100',
        type: 'text',
        slug: '',
        label: {
            ru: "",
            uz: "",
            cryl: ""
        },
        placeholder: {
            ru: "",
            uz: "",
            cryl: ""
        },
        tooltip: {
            ru: "",
            uz: "",
            cryl: ""
        },
        pattern: '',
        validation: {},
        min_value: '',
        max_value: '',

        required: false

    })

    if (!formData.value.fields[blockIndex].vertical) {

        formData.value.fields[blockIndex].inputs.forEach(item => {
            item.width = 100 / formData.value.fields[blockIndex].inputs.length
        })
    }


}

const addBlock = (): void => {

    formData.value.fields.push(
        {
            title: {
                ru: "",
                uz: "",
                cryl: ""
            },
            vertical: true,
            inputs: []
        }
    )

}

const copyField = (data: OneField, blockIndex: number): void => {

    const newData = JSON.parse(JSON.stringify(data))
    newData.id = null
    newData.block_id = null

    formData.value.fields[blockIndex].inputs.push(newData)

}

const copyBlock = (data: OneBlock): void => {
    const newBlock = JSON.parse(JSON.stringify(data))

    newBlock.id = null
    newBlock.inputs.forEach(item => {
        item.id = null
        item.block_id = null
    })
    formData.value.fields.push(newBlock)

}

const deleteBlock = (blockIndex: number): void => {

    formData.value.fields.splice(blockIndex, 1)
}

const deleteField = (index: number, blockIndex: number): void => {


    formData.value.fields[blockIndex].inputs.splice(index, 1)


}

const bindField = (field: { unique_name: string, title: string }, index: number, blockIndex: number, input: OneField): void => {
    console.log(field);

    if (field.unique_name == 'text') {
        formData.value.fields[blockIndex].inputs[index] = {
            id: input.id ? input.id : null,
            block_id: input.block_id ? input.block_id : null,
            width: formData.value.fields[blockIndex].inputs[index].width,
            type: field.unique_name,
            slug: '',
            label: {
                ru: "",
                uz: "",
                cryl: ""
            },
            placeholder: {
                ru: "",
                uz: "",
                cryl: ""
            },
            tooltip: {
                ru: "",
                uz: "",
                cryl: ""
            },
            pattern: '',
            validation: {},
            min_value: 0,
            max_value: 0,
            required: false

        }

    }

    else if (field.unique_name == 'range') {
        formData.value.fields[blockIndex].inputs[index] = {
            id: input.id ? input.id : null,
            block_id: input.block_id ? input.block_id : null,
            width: formData.value.fields[blockIndex].inputs[index].width,
            type: field.unique_name,
            slug: '',
            label: {
                ru: "",
                uz: "",
                cryl: ""
            },
            tooltip: {
                ru: "",
                uz: "",
                cryl: ""
            },
            is_multiple: false,
            options: [],
            validation: {},
            min_value: 0,
            max_value: 0,
            required: false

        }
    }

    else if (field.unique_name == 'switch' || field.unique_name == 'checkbox' || field.unique_name == 'radio' || field.unique_name == 'chips') {
        formData.value.fields[blockIndex].inputs[index] = {
            id: input.id ? input.id : null,
            block_id: input.block_id ? input.block_id : null,
            width: formData.value.fields[blockIndex].inputs[index].width,
            type: field.unique_name,
            slug: '',
            label: {
                ru: "",
                uz: "",
                cryl: ""
            },
            tooltip: {
                ru: "",
                uz: "",
                cryl: ""
            },
            validation: {},
            min_value: 0,
            max_value: 0,
            required: false

        }
    }

    else if (field.unique_name == 'single_select_drop_down' || field.unique_name == 'multi_select_drop_down') {


        formData.value.fields[blockIndex].inputs[index] = {
            id: input.id ? input.id : null,
            block_id: input.block_id ? input.block_id : null,
            width: formData.value.fields[blockIndex].inputs[index].width,
            type: field.unique_name,
            slug: '',
            label: {
                ru: "",
                uz: "",
                cryl: ""
            },
            placeholder: {
                ru: "",
                uz: "",
                cryl: ""
            },
            tooltip: {
                ru: "",
                uz: "",
                cryl: ""
            },
            options: [],
            pattern: '',
            validation: {},
            min_value: 0,
            max_value: 0,
            required: false

        }
    }

    else if (field.unique_name == 'file_upload' || field.unique_name == 'image_upload') {
        formData.value.fields[blockIndex].inputs[index] = {
            id: input.id ? input.id : null,
            block_id: input.block_id ? input.block_id : null,
            width: formData.value.fields[blockIndex].inputs[index].width,
            type: field.unique_name,

            slug: '',
            label: {
                ru: "",
                uz: "",
                cryl: ""
            },
            placeholder: {
                ru: "",
                uz: "",
                cryl: ""
            },
            tooltip: {
                ru: "",
                uz: "",
                cryl: ""
            },
            pattern: '',
            size_type: '',
            min_value: 0,
            max_value: 0,

            required: false

        }
    }

    else if (field.unique_name == 'map') {
        formData.value.fields[blockIndex].inputs[index] = {
            id: input.id ? input.id : null,
            block_id: input.block_id ? input.block_id : null,
            width: formData.value.fields[blockIndex].inputs[index].width,
            type: field.unique_name,
            slug: '',
            label: {
                ru: "",
                uz: "",
                cryl: ""
            },
            tooltip: {
                ru: "",
                uz: "",
                cryl: ""
            },
            is_multiple: false,
            pattern: '',
            required: false

        }
    }

}


const dragStart = (index: number, data: any, blockIndex: number, e: any): void => {

    setTimeout(() => {
        e.target.style.opacity = '0'
    }, 0);

    dragData.value.blockIndex = blockIndex
    dragData.value.index = index
    dragData.value.data = data

}

const dragEnter = (_e: Event): void => {


}

const dragLeave = (_e: any): void => {


}
const dragEnd = (e: any): void => {
    e.target.style.opacity = '1'
    dragging.value = -1;
}

const dragFinish = (index: number, blockIndex: number): void => {


    if (blockIndex == dragData.value.blockIndex) {

        formData.value.fields[blockIndex].inputs.splice(index, 0, formData.value.fields[blockIndex].inputs.splice(dragData.value.index, 1)[0]);
    } else {
        alert("Boshqa blockga qo'shomisan")
        return
    }

}

const dragStart2 = (index: number): void => {
    dragging.value = index;

}

const dragEnter2 = (_e: any): void => {


}

const dragLeave2 = (_e: any): void => {


}
const dragEnd2 = (_e: any): void => {

    dragging.value = -1;
}

const dragFinish2 = (index: number, blockIndex: number): void => {

    formData.value.fields[blockIndex].inputs.splice(index, 0, formData.value.fields[blockIndex].inputs.splice(dragging.value, 1)[0]);

}

const bindCurrentIndex = (index: number, data: OneField, blockIndex: number): void => {

    if (index === defaultIndex.value) {
        isOpen[blockIndex] = false

        defaultIndex.value = null
        currentData.value = {
            type: '',
            width: '',
            id: null
        }
    }
    else {
        isOpen[blockIndex] = true
        defaultIndex.value = index
        currentData.value = data
    }

}

const getVal = (item: LngData) => {


    nextTick(() => {
        lngObj.value = item

        openShowModal.value = !openShowModal.value

    })

}

const saveForms = async () => {
    try {

        if (route.params.id) {
            await formStore.updateOneForm({
                id: route.params.id,
                data: formData.value
            })
        } else {

            await formStore.AddForms(formData.value)
        }
        router.push('/forms')
        toast.success('Успешно!')

    } catch (err) {
        toast.error('Ошибка!')
    }

}

const getWidth = (width: number | string, index: number, blockIndex: number): void => {

    if (formData.value.fields[blockIndex].inputs.length > 1) {
        let restOfCount = 100 - width
        let newIndex = index

        if (newIndex == 0) {
            newIndex++
        } else {
            newIndex--
        }


        formData.value.fields[blockIndex].inputs[newIndex].width = restOfCount

    }


}

</script>


<template>
    <div>
        <!-- {{ formStore.getOneForm.data.data }} -->
        <AddEditModal @openModal="openModal" :openShowModal="openShowModal" :modalValue="lngObj" />

        <div class="w-11/12">


            <!-- {{ formData }} -->
            <div class="uk-card uk-card-default p-4 bg-slate-50 rounded mb-4">

                <label for="title">
                    {{ t('name') }}
                    <input id="title"
                        class="mt-1 block rounded-md border border-slate-300 bg-white px-3 py-2 text-sm text-gray-600 shadow-sm duration-150 placeholder:text-slate-400 focus:border-primary focus:outline-none focus:ring-1 dark:border-gray-600 dark:bg-darkLayoutStorm dark:text-gray-300 w-full"
                        type="text" :placeholder="t('name')" aria-label="Input" readonly v-model="formData.name.ru"
                        @click="editItem(formData.name)">
                </label>


                <label for="description">
                    {{ t('description') }}
                    <input id="description"
                        class="mt-1 block rounded-md border border-slate-300 bg-white px-3 py-2 text-sm text-gray-600 shadow-sm duration-150 placeholder:text-slate-400 focus:border-primary focus:outline-none focus:ring-1 dark:border-gray-600 dark:bg-darkLayoutStorm dark:text-gray-300 w-full"
                        type="text" :placeholder="t('description')" aria-label="Input" readonly
                        v-model="formData.description.uz" @click="editItem(formData.description)">
                </label>

                <div class="mt-4 flex gap-6">
                    <div class="w-1/4 flex items-center pl-4 border border-gray-200 rounded dark:border-gray-700">
                        <input id="bordered-radio-1" type="radio" :value="2" name="bordered-radio" v-model="formData.target"
                            class="w-4 h-4 text-blue-600 bg-gray-100 border-gray-300  dark:bg-gray-700 dark:border-gray-600">
                        <label for="bordered-radio-1" class="w-full py-4 ml-2 dark:text-gray-300">Filter
                        </label>
                    </div>
                    <div class="w-1/4 flex items-center pl-4 border border-gray-200 rounded dark:border-gray-700">
                        <input checked id="bordered-radio-2" type="radio" :value="1" name="bordered-radio"
                            v-model="formData.target"
                            class="w-4 h-4 text-blue-600 bg-gray-100 border-gray-300  dark:bg-gray-700 dark:border-gray-600">
                        <label for="bordered-radio-2" class="w-full py-4 ml-2 dark:text-gray-300">
                            Form</label>
                    </div>
                </div>

            </div>

            <!-- <CreateSection /> -->

            <div v-for="(block, blockIndex) in formData.fields" :key="blockIndex">

                <div class="uk-card uk-card-body bg-slate-50 rounded relative mb-6">

                    <div class="flex items-center justify-between mb-4 p-2">
                        <!-- <input class="uk-input w-1/4 bg-slate-200" type="text" placeholder="Title of block"
                            aria-label="Input" readonly v-model="block.title.uz" @click="editItem(block.title)"> -->

                        <label for="Title of block" class="w-1/4">
                            {{ t('title_of_block') }}
                            <input id="Title of block"
                                class="w-full mt-1 block rounded-md border border-slate-300 bg-white px-3 py-2 text-sm text-gray-600 shadow-sm duration-150 placeholder:text-slate-400 focus:border-primary focus:outline-none focus:ring-1 dark:border-gray-600 dark:bg-darkLayoutStorm dark:text-gray-300"
                                type="text" :placeholder="t('title_of_block')" aria-label="Input" readonly
                                v-model="block.title.uz" @click="editItem(block.title)">
                        </label>

                        <div class="flex items-center justify-end">
                            <span class="mr-3">{{ block.vertical ? t('vertical') : t('horizontal') }}</span>
                            <label className="relative inline-flex items-center cursor-pointer"
                                :title="block.inputs.length > 2 ? 'You cannot change state because of inputs length' : ''"
                                uk-tooltip="pos: top">
                                <input type="checkbox" :checked="block.vertical" class="sr-only peer"
                                    v-model="block.vertical" :disabled="block.inputs.length > 2" />
                                <div
                                    className="w-11 h-6 bg-gray-200 peer-focus:outline-none 
                                                            rounded-full peer dark:bg-gray-700 peer-checked:after:translate-x-full peer-checked:after:border-white after:content-[''] after:absolute after:top-[2px] after:left-[2px] after:bg-white after:border-gray-300 after:border after:rounded-full after:h-5 after:w-5 after:transition-all dark:border-gray-600 peer-checked:bg-primary">
                                </div>
                            </label>
                        </div>
                    </div>



                    <template v-if="!block.vertical">
                        <div data-draggable="horizontal" :class="!block.vertical ? 'flex items-start gap-2 mt-14' : ''">
                            <div class="flex items-center mb-4 cursor-move relative" draggable="true"
                                v-for="(input, index) in block.inputs" :key="index"
                                :style="`width: ${input.width}% !important;`"
                                @dragstart="dragStart(index, input, blockIndex, $event)" @dragover.prevent
                                @dragenter="dragEnter" @dragleave="dragLeave" @dragend="dragEnd"
                                @drop="dragFinish(index, blockIndex)">

                                <input type="text" v-model="input.width" class="input-style p-2 input-position"
                                    placeholder="field width" @keyup="getWidth(input.width, index, blockIndex)">
                                <ul uk-accordion class="w-full">
                                    <li class="filed-style flex flex-col"
                                        @click="bindCurrentIndex(index, input, blockIndex)">
                                        <div class="uk-accordion-title text-center flex items-center">
                                            <span class="w-full m-auto">{{ input.type }}
                                            </span>
                                            <a @click.stop="" href="#" class="uk-icon-button" type="button"
                                                uk-icon="more-vertical"></a>
                                            <div uk-dropdown="mode: click">
                                                <ul class="uk-nav uk-dropdown-nav">

                                                    <li v-for="(field, index2) in fieldList" :key="index2"
                                                        class="px-5 rounded"
                                                        :class="field.unique_name == input.type ? 'bg-slate-200' : ''"
                                                        @click.stop="bindField(field, index, blockIndex, input)">
                                                        <div class="box-field">{{
                                                            field.title
                                                        }}</div>
                                                    </li>


                                                </ul>
                                            </div>
                                            <div class="flex items-center action-wrapper">
                                                <div class="uk-icon-button" uk-icon="copy"
                                                    @click.stop="copyField(input, blockIndex)"></div>
                                                <div @click.stop="deleteField(index, blockIndex)" class="uk-icon-button"
                                                    uk-icon="trash"></div>
                                            </div>
                                        </div>




                                    </li>


                                </ul>


                            </div>
                        </div>



                        <div class="uk-accordion-content" v-if="isOpen[blockIndex]">

                            <template v-if="currentData.type == 'text'">

                                <TextLayout :id="defaultIndex + '-horizontal-' + blockIndex" :data="currentData"
                                    @getVal="getVal" />

                            </template>

                            <template v-else-if="currentData.type == 'chips'">

                                <CheckboxLayout :id="defaultIndex + '-horizontal-' + blockIndex" :data="currentData"
                                    @getVal="getVal" />

                            </template>

                            <template v-else-if="currentData.type == 'range'">

                                <RangeLayout :data="currentData" @getVal="getVal" />

                            </template>

                            <template v-else-if="currentData.type == 'single_select_drop_down'">

                                <DropdownLayout :id="defaultIndex + '-horizontal-' + blockIndex" :data="currentData"
                                    @getVal="getVal" />

                            </template>

                            <template v-else-if="currentData.type == 'multi_select_drop_down'">

                                <DropdownLayout :id="defaultIndex + '-horizontal-' + blockIndex" :data="currentData"
                                    @getVal="getVal" />

                            </template>

                            <template v-else-if="currentData.type == 'switch'">

                                <CheckboxLayout :id="defaultIndex + '-horizontal-' + blockIndex" :data="currentData"
                                    @getVal="getVal" />

                            </template>

                            <template v-else-if="currentData.type == 'checkbox'">

                                <CheckboxLayout :data="currentData" @getVal="getVal" />

                            </template>

                            <template v-else-if="currentData.type == 'radio'">

                                <CheckboxLayout :id="defaultIndex + '-horizontal-' + blockIndex" :data="currentData"
                                    @getVal="getVal" />

                            </template>

                            <template v-else-if="currentData.type == 'file_upload'">

                                <FileLayout :id="defaultIndex + '-horizontal-' + blockIndex" :data="currentData"
                                    @getVal="getVal" />

                            </template>

                            <template v-else-if="currentData.type == 'image_upload'">

                                <ImageLayout :id="defaultIndex + '-horizontal-' + blockIndex" :data="currentData"
                                    @getVal="getVal" />

                            </template>
                        </div>
                    </template>

                    <template v-else>
                        <div data-draggable="horizontal" :class="!block.vertical ? 'flex items-start gap-2' : ''">
                            <div class="flex items-center mb-4 cursor-move" draggable="true"
                                v-for="(input, index) in block.inputs" :key="index"
                                :style="`width: ${input.width}% !important;`"
                                @dragstart="dragStart(index, input, blockIndex, $event)" @dragover.prevent
                                @dragenter="dragEnter" @dragleave="dragLeave" @dragend="dragEnd"
                                @drop="dragFinish(index, blockIndex)">
                                <ul uk-accordion class="w-full">
                                    <li class="filed-style flex flex-col">
                                        <div class="uk-accordion-title text-center flex items-center">
                                            <span class="w-full ml-24">{{ input.type }}
                                            </span>
                                            <a @click.stop="" href="#" class="uk-icon-button" type="button"
                                                uk-icon="more-vertical"></a>
                                            <div uk-dropdown="mode: click">
                                                <ul class="uk-nav uk-dropdown-nav">

                                                    <li v-for="(field, index2) in fieldList" :key="index2"
                                                        class="px-5 rounded"
                                                        :class="field.unique_name == input.type ? 'bg-slate-200' : ''"
                                                        @click.stop="bindField(field, index, blockIndex, input)">
                                                        <div class="box-field">{{
                                                            field.title
                                                        }}</div>
                                                    </li>


                                                </ul>
                                            </div>
                                            <div class="flex items-center action-wrapper">
                                                <div class="uk-icon-button" uk-icon="copy"
                                                    @click.stop="copyField(input, blockIndex)"></div>
                                                <div @click.stop="deleteField(index, blockIndex)" class="uk-icon-button"
                                                    uk-icon="trash"></div>
                                            </div>
                                        </div>


                                        <div class="uk-accordion-content">

                                            <template v-if="input.type == 'text'">

                                                <TextLayout :id="index + '-vertical-' + blockIndex" :data="input"
                                                    @getVal="getVal" />

                                            </template>

                                            <template v-else-if="input.type == 'chips'">

                                                <CheckboxLayout :data="input" @getVal="getVal" />

                                            </template>

                                            <template v-else-if="input.type == 'range'">

                                                <RangeLayout :data="input" @getVal="getVal" />

                                            </template>

                                            <template v-else-if="input.type == 'single_select_drop_down'">

                                                <DropdownLayout :id="index + '-vertical-' + blockIndex" :data="input"
                                                    @getVal="getVal" />

                                            </template>

                                            <template v-else-if="input.type == 'multi_select_drop_down'">

                                                <DropdownLayout :id="index + '-vertical-' + blockIndex" :data="input"
                                                    @getVal="getVal" />

                                            </template>

                                            <template v-else-if="input.type == 'switch'">

                                                <CheckboxLayout :data="input" @getVal="getVal" />

                                            </template>

                                            <template v-else-if="input.type == 'checkbox'">

                                                <CheckboxLayout :data="input" @getVal="getVal" />

                                            </template>

                                            <template v-else-if="input.type == 'radio'">

                                                <CheckboxLayout :data="input" @getVal="getVal" />

                                            </template>

                                            <template v-else-if="input.type == 'file_upload'">

                                                <FileLayout :id="index + '-vertical-' + blockIndex" :data="input"
                                                    @getVal="getVal" />

                                            </template>

                                            <template v-else-if="input.type == 'image_upload'">

                                                <ImageLayout :id="index + '-vertical-' + blockIndex" :data="input"
                                                    @getVal="getVal" />

                                            </template>

                                        </div>

                                    </li>


                                </ul>


                            </div>
                        </div>
                    </template>

                    <button class="btn-outline-secondary !border-spacing-1 mx-auto my-3 w-full"
                        @click="addField(blockIndex)">
                        <span class="" uk-icon="plus"></span>
                    </button>


                    <div class="flex flex-col items-center action-bar-box">
                        <!-- <div class="uk-icon-button" uk-icon="plus-circle" @click="addBlock"></div> -->
                        <div class="uk-icon-button" uk-icon="copy" @click="copyBlock(block)"></div>
                        <div class="uk-icon-button" uk-icon="trash" @click="deleteBlock(blockIndex)"></div>
                    </div>

                </div>
            </div>

            <button class="btn-outline-secondary !border-spacing-1 mx-auto my-3 w-full" @click="addBlock">
                <span class="" uk-icon="plus"></span>
            </button>
            <div class="flex items-center gap-2 justify-end">
                <button @click="$router.push('/forms')" class="btn-danger">Отменить</button>
                <button class="btn-success" @click="saveForms">Сохранить</button>
            </div>
        </div>

    </div>
</template>

<style>
.box-field {
    display: flex;
    align-items: center;
    -moz-column-gap: 0.25em;
    column-gap: 0.25em;
    text-decoration: none;
    padding: 5px 0;
    color: #999;
}

.box-field:hover {
    color: #666
}

.input-position {
    width: 100px;
    position: absolute;
    left: 0;
    top: -45px;
}

.add-forms-card {
    padding: 35px;
    width: 300px;
    background-color: #f5f2f2;
}

.filed-style {
    border-radius: 4px;
    border: 1px solid #8EBFFF;
    background: #F9FAFB;
    padding: 6px;
}

.input-style {
    border-radius: 4px;
    border: 1px solid rgba(0, 0, 0, 0.10);
    background: #F9FAFB;
}

.action-wrapper {
    border-radius: 2px;
    border: 1px solid rgba(0, 0, 0, 0.10);
    background: #FFF;
}

.border-after {
    position: relative;
}

.border-after::after {
    position: absolute;
    left: -15px;
    top: 50%;
    transform: translateY(-50%);
    display: block;
    content: '';
    width: 1px;
    height: 42px;
    opacity: 0.10000000149011612;
    background: #000;
}

.action-bar-box {
    position: absolute;
    top: 0;
    right: -42px;
    width: 38px;
    padding: 12px 9px;
    border-radius: 4px;
    border: 1px solid rgba(0, 0, 0, 0.10);
    opacity: 0.699999988079071;
    background: #FFF;
}
</style>
